#ifndef CI_STRING_H
#define CI_STRING_H

// case ignore string
// this class is left in namespace std

// this code is authored by herbs@cntc.com (Herb Sutter)
// http://gcc.gnu.org/onlinedocs/libstdc++/21_strings/gotw29a.txt


// c++ headers
#include <cctype>
#include <string>
#include <cstring>

// BSD C headers
#include <strings.h>
#undef strcasecmp
#undef strncasecmp
namespace std {
	using ::strcasecmp;
	using ::strncasecmp;

	struct ci_char_traits : public char_traits<char>
		// just inherit all the other functions
		//  that we don't need to override
		{
			inline bool eq( char c1, char c2 ) {
				return tolower(c1) == tolower(c2);
			}

			inline bool ne( char c1, char c2 ) {
				return tolower(c1) != tolower(c2);
			}

			inline bool lt( char c1, char c2 ) {
				return tolower(c1) < tolower(c2);
			}

			inline int compare( const char* s1, const char* s2, size_t n ) {
				return strncasecmp(s1, s2, n);
			}

			inline const char* find( const char* s, int n, char a ) {
				int ica=tolower(a);
				while( (n-- > 0) && (tolower(*s)!=ica) ) ++s;
				return (n >= 0) ? s : 0;
			}
	};
	
	typedef basic_string<char, ci_char_traits> ci_string;
}



#endif

